=== added directory 'product_customs_rate'
=== added file 'product_customs_rate/__init__.py'
--- product_customs_rate/__init__.py	1970-01-01 00:00:00 +0000
+++ product_customs_rate/__init__.py	2012-06-30 00:53:59 +0000
@@ -0,0 +1,28 @@
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 Cubic ERP - Teradata SAC (<http://cubicerp.com>).
+#       (Modified by)   Vauxoo - http://www.vauxoo.com/
+#                       info Vauxoo (info@vauxoo.com)
+#    Modified by - juan@vauxoo.com
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+import product_customs_rate
+import product
+
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'product_customs_rate/__openerp__.py'
--- product_customs_rate/__openerp__.py	1970-01-01 00:00:00 +0000
+++ product_customs_rate/__openerp__.py	2012-06-30 01:03:31 +0000
@@ -0,0 +1,51 @@
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 Cubic ERP - Teradata SAC (<http://cubicerp.com>).
+#       (Modified by)   Vauxoo - http://www.vauxoo.com/
+#                       info Vauxoo (info@vauxoo.com)
+#    Modified by - juan@vauxoo.com
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+{
+    "name": "Customs Rate Management",
+    "version": "1.0",
+    "description": """
+Management of Customs Rate
+
+Gestión de Customs Rate (Nandina y subpartida nacional)
+
+    """,
+    "author": "Cubic ERP & Vauxoo",
+    "website": "http://cubicERP.com & http://vauxoo.com",
+    "category": "Finance",
+    "depends": [
+            "product",
+            ],
+    "data":[
+    ],
+    "demo_xml": [
+    ],
+    "update_xml": [
+        'security/product_customs_rate_security.xml',
+        'security/ir.model.access.csv',
+        'product_view.xml',
+    ],
+    "active": False,
+    "installable": True,
+    "certificate" : False,
+}
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added directory 'product_customs_rate/i18n'
=== added file 'product_customs_rate/i18n/es.po'
--- product_customs_rate/i18n/es.po	1970-01-01 00:00:00 +0000
+++ product_customs_rate/i18n/es.po	2012-06-29 01:22:17 +0000
@@ -0,0 +1,95 @@
+# This file contains the translation of the following modules:
+#	* product_customs_rate
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: OpenERP Server 6.1\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2012-06-29 01:06+0000\n"
+"PO-Revision-Date: 2012-06-28 20:20-0600\n"
+"Last-Translator: juan <juan@vauxoo.com>\n"
+"Language-Team: \n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: \n"
+
+#. module: product_customs_rate
+#: view:product.customs.rate:0
+msgid "Taxes Mapping"
+msgstr "Mapeo de Impuestos"
+
+#. module: product_customs_rate
+#: model:ir.actions.act_window,name:product_customs_rate.product_customs_rate_list_action
+#: model:ir.model,name:product_customs_rate.model_product_customs_rate
+#: model:ir.ui.menu,name:product_customs_rate.product_customs_rate_menu
+#: field:product.template,customs_rate_id:0
+msgid "Customs Rate"
+msgstr "Fracción Arancelaria"
+
+#. module: product_customs_rate
+#: constraint:product.customs.rate:0
+msgid "Error ! You can not create recursive Customs Rate."
+msgstr "¡Error! No puedes crear recursividad a Fracción Arancelaria"
+
+#. module: product_customs_rate
+#: field:product.customs.rate,complete_name:0
+#: field:product.customs.rate,name:0
+msgid "Name"
+msgstr "Nombre"
+
+#. module: product_customs_rate
+#: selection:product.customs.rate,type:0
+msgid "Normal"
+msgstr "Normal"
+
+#. module: product_customs_rate
+#: model:ir.model,name:product_customs_rate.model_product_template
+msgid "Product Template"
+msgstr "Plantilla del producto"
+
+#. module: product_customs_rate
+#: constraint:product.template:0
+msgid "Error: The default UOM and the purchase UOM must be in the same category."
+msgstr "Error: La UdM por defecto y la UdM de compra debe estar en la misma categoría."
+
+#. module: product_customs_rate
+#: field:product.customs.rate,tax_ids:0
+msgid "Taxes"
+msgstr "Impuestos"
+
+#. module: product_customs_rate
+#: view:product.customs.rate:0
+msgid "Customs Rate List"
+msgstr "Lista Fracciones Arancelarias"
+
+#. module: product_customs_rate
+#: view:product.customs.rate:0
+msgid "Product Customs Rate"
+msgstr "Producto Fracción Arancelaria"
+
+#. module: product_customs_rate
+#: field:product.customs.rate,code:0
+msgid "Code"
+msgstr "Código"
+
+#. module: product_customs_rate
+#: field:product.customs.rate,child_ids:0
+msgid "Child Customs Rate"
+msgstr "Hijo Fracción Arancelaria"
+
+#. module: product_customs_rate
+#: field:product.customs.rate,type:0
+msgid "Customs Rate Type"
+msgstr "Tipo de Fracción Arancelaria"
+
+#. module: product_customs_rate
+#: field:product.customs.rate,parent_id:0
+msgid "Parent Customs Rate"
+msgstr "Padre  Fracción Arancelaria"
+
+#. module: product_customs_rate
+#: selection:product.customs.rate,type:0
+msgid "View"
+msgstr "Vista"
+

=== added file 'product_customs_rate/product.py'
--- product_customs_rate/product.py	1970-01-01 00:00:00 +0000
+++ product_customs_rate/product.py	2012-06-30 00:53:59 +0000
@@ -0,0 +1,33 @@
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 Cubic ERP - Teradata SAC (<http://cubicerp.com>).
+#       (Modified by)   Vauxoo - http://www.vauxoo.com/
+#                       info Vauxoo (info@vauxoo.com)
+#    Modified by - juan@vauxoo.com
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import osv, fields
+
+class product_template(osv.osv):
+    _name = 'product.template'
+    _inherit = 'product.template'
+    _columns = {
+        'customs_rate_id' : fields.many2one('product.customs.rate','Customs Rate',domain=[('type','=','normal')]),
+    }
+
+product_template()

=== added file 'product_customs_rate/product_customs_rate.py'
--- product_customs_rate/product_customs_rate.py	1970-01-01 00:00:00 +0000
+++ product_customs_rate/product_customs_rate.py	2012-07-04 23:10:46 +0000
@@ -0,0 +1,96 @@
+# -*- encoding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 Cubic ERP - Teradata SAC (<http://cubicerp.com>).
+#       (Modified by)   Vauxoo - http://www.vauxoo.com/
+#                       info Vauxoo (info@vauxoo.com)
+#    Modified by - juan@vauxoo.com
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import osv, fields
+
+class product_customs_rate(osv.osv):
+
+    def name_get(self, cr, uid, ids, context=None):
+        if not len(ids):
+            return []
+        reads = self.read(cr, uid, ids, ['name','code'], context=context)
+        res = []
+        for record in reads:
+            name = record['name']
+            if record['code']:
+                name = record['code']+': '+name
+            res.append((record['id'], name))
+        return res
+
+    def name_search(self, cr, user, name, args=None, operator='ilike', context=None, limit=100):
+        if not args:
+            args = []
+        args = args[:]
+        ids = []
+        if name:
+            ids = self.search(cr, user, [('code', '=like', name+"%")]+args, limit=limit)
+            if not ids:
+                ids = self.search(cr, user, [('name', operator, name)]+ args, limit=limit)
+            if not ids and len(name.split()) >= 2:
+                #Separating code and name of account for searching
+                operand1,operand2 = name.split(': ',1) #name can contain spaces e.g. OpenERP S.A.
+                ids = self.search(cr, user, [('code', operator, operand1), ('name', operator, operand2)]+ args, limit=limit)
+        else:
+            ids = self.search(cr, user, args, context=context, limit=limit)
+        return self.name_get(cr, user, ids, context=context)
+
+    def _name_get_fnc(self, cr, uid, ids, prop, unknow_none, context=None):
+        res = self.name_get(cr, uid, ids, context=context)
+        return dict(res)
+
+    _name = 'product.customs.rate'
+    _description = 'Customs Rate'
+    _columns = {
+        'code' : fields.char('Code', size=64),
+        'name': fields.char('Name', size=2048, required=True, translate=True, select=True),
+        'active': fields.boolean('Active'),
+        'complete_name': fields.function(_name_get_fnc, method=True, type="char", string='Name'),
+        'parent_id': fields.many2one('product.customs.rate','Parent Customs Rate', select=True, domain=[('type','=','view')]),
+        'child_ids': fields.one2many('product.customs.rate', 'parent_id', string='Child Customs Rate'),
+        'type': fields.selection([('view','View'), ('normal','Normal')], 'Customs Rate Type',required=True),
+        'tax_ids' : fields.many2many('account.tax','product_customs_rate_tax','customs_rate_id','tax_id','Taxes')
+
+    }
+    _defaults = {
+        'active': 1,
+        'type': 'normal',
+    }  
+    _order = "code"
+    def _check_recursion(self, cr, uid, ids, context=None):
+        level = 100
+        while len(ids):
+            cr.execute('select distinct parent_id from product_customs_rate where id IN %s',(tuple(ids),))
+            ids = filter(None, map(lambda x:x[0], cr.fetchall()))
+            if not level:
+                return False
+            level -= 1
+        return True
+
+    _constraints = [
+        (_check_recursion, 'Error ! You can not create recursive Customs Rate.', ['parent_id'])
+    ]
+    def child_get(self, cr, uid, ids):
+        return [ids]
+
+product_customs_rate()
+

=== added file 'product_customs_rate/product_view.xml'
--- product_customs_rate/product_view.xml	1970-01-01 00:00:00 +0000
+++ product_customs_rate/product_view.xml	2012-07-04 23:10:46 +0000
@@ -0,0 +1,63 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<openerp>
+    <data>
+        
+        <record model='ir.ui.view' id='product_customs_rate_form_view'>
+            <field name='name'>Product Customs Rate Form Inherit</field>
+            <field name='model'>product.product</field>
+            <field name='inherit_id' ref='account.product_normal_form_view'/>
+            <field name='type'>form</field>
+            <field name='arch' type='xml'>
+                <xpath expr="/form/notebook/page[@string='Accounting']/group[@name='properties']" position="inside">
+                    
+                    <!--separator string="Cost Center" colspan="2"/-->
+                    <field name="customs_rate_id"/>
+                </xpath>
+            </field>
+        </record>
+
+        <record model="ir.actions.act_window" id="product_customs_rate_list_action">
+            <field name="name">Customs Rate</field>
+            <field name="res_model">product.customs.rate</field>
+            <field name="view_type">form</field>
+            <field name="view_mode">tree,form</field>
+        </record>
+        
+        <record id="view_product_customs_rate_tree" model="ir.ui.view">
+            <field name="name">Product Customs Rate List</field>
+            <field name="model">product.customs.rate</field>
+            <field name="type">tree</field>
+            <field name="field_parent">child_ids</field>
+            <field name="priority">100</field>
+            <field name="arch" type="xml">
+                <tree string="Customs Rate List" toolbar="1">
+                    <field name="name"/>
+                    <field name="code"/>
+                    <field name="active"/>
+                </tree>
+            </field>
+        </record>
+        
+        <record id="view_product_customs_rate_code_form" model="ir.ui.view">
+            <field name="name">Product Customs Rate Form</field>
+            <field name="model">product.customs.rate</field>
+            <field name="type">form</field>
+            <field name="arch" type="xml">
+                <form string="Product Customs Rate">
+                    <field name="name"/>
+                    <field name="code"/>
+                    <field name="parent_id"/>
+                    <field name="type"/>
+                    <field name="active"/>
+                    <separator string="Taxes Mapping" colspan="4"/>
+                    <field colspan="4" name="tax_ids" nolabel="1" attrs="{'readonly':[('type','=','view')]}"/>
+                </form>
+            </field>
+        </record>
+                
+        <menuitem name='Customs Rate' id = 'product_customs_rate_menu' parent='account.next_id_27' sequence='200' action="product_customs_rate_list_action"/>
+        <menuitem name='Customs Rate' id = 'product_customs_rate_menu' parent='product.prod_config_main' sequence='250'	action="product_customs_rate_list_action"/>
+        
+    </data>
+</openerp>

=== added directory 'product_customs_rate/security'
=== added file 'product_customs_rate/security/ir.model.access.csv'
--- product_customs_rate/security/ir.model.access.csv	1970-01-01 00:00:00 +0000
+++ product_customs_rate/security/ir.model.access.csv	2012-06-29 22:16:57 +0000
@@ -0,0 +1,3 @@
+id,name,model_id:id,group_id:id,perm_read,perm_write,perm_create,perm_unlink
+access_product_customs_rate_user,product.product.customs.rate.user,model_product_customs_rate,,1,0,0,0
+access_product_customs_rate_manager,product.product.customs.rate.manager,model_product_customs_rate,,1,1,1,1

=== added file 'product_customs_rate/security/product_customs_rate_security.xml'
--- product_customs_rate/security/product_customs_rate_security.xml	1970-01-01 00:00:00 +0000
+++ product_customs_rate/security/product_customs_rate_security.xml	2012-06-29 19:10:50 +0000
@@ -0,0 +1,16 @@
+<?xml version="1.0" encoding="utf-8"?>
+<openerp><data>
+
+<!--
+ Users Groups
+-->
+    <record model="res.groups" id="group_customs_rate_manager">
+        <field name="name">Customs Rate / Manager</field>
+    </record>
+   
+    <record model="res.groups" id="group_customs_rate_user">
+        <field name="name">Customs Rate / User</field>
+    </record>
+   
+</data></openerp>
+

